/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.commons;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.emftext.language.java.annotations.AnnotationInstance;
import org.emftext.language.java.classifiers.AnonymousClass;
import org.emftext.language.java.classifiers.ConcreteClassifier;
import org.emftext.language.java.classifiers.Interface;
import org.emftext.language.java.containers.CompilationUnit;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Commentable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.java.commons.Commentable#getComments <em>Comments</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.java.commons.CommonsPackage#getCommentable()
 * @model abstract="true"
 * @generated
 */
public interface Commentable extends EObject
{
  /**
   * Returns the value of the '<em><b>Comments</b></em>' attribute list.
   * The list contents are of type {@link java.lang.String}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Comments</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Comments</em>' attribute list.
   * @see org.emftext.language.java.commons.CommonsPackage#getCommentable_Comments()
   * @model unique="false"
   * @generated
   */
  EList<String> getComments();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the <code>org.emftext.language.java.classifiers.ConcreteClassifier</code>
   *  representing the class with the given classified name.
   *  
   *  @param name classified name of the ConcreteClassifier
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='return ( org.emftext.language.java.classifiers.ConcreteClassifier ) org.eclipse.emf.ecore.util.EcoreUtil .resolve ( org.emftext.language.java.JavaClasspath .get ( this ) .getClassifier ( name ) , this ) ; \n'"
   * @generated
   */
  ConcreteClassifier getConcreteClassifier(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='return ( org.emftext.language.java.classifiers.ConcreteClassifier ) org.emftext.language.java.JavaClasspath .get ( this ) .getClassifier ( name ) ; \n'"
   * @generated
   */
  ConcreteClassifier getConcreteClassifierProxy(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds all <code>org.emftext.language.java.classifiers.ConcreteClassifier</code>
   *  representing the classes in the given package or a single class from that package.
   *  
   *  @param packageName name of the package
   *  for all classifiers or name of a single classifier
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.common.util.EList < org.emftext.language.java.classifiers.ConcreteClassifier > result = new org.emftext.language.java.util.UniqueEList < org.emftext.language.java.classifiers.ConcreteClassifier > ( ) ; \nfor ( org.eclipse.emf.ecore.EObject classifier : org.emftext.language.java.JavaClasspath .get ( this ) .getClassifiers ( packageName , classifierQuery ) ) { \n\tresult .add ( ( org.emftext.language.java.classifiers.ConcreteClassifier ) org.eclipse.emf.ecore.util.EcoreUtil .resolve ( classifier , this ) ) ; \n} \nreturn result ; \n'"
   * @generated
   */
  EList<ConcreteClassifier> getConcreteClassifiers(String packageName, String classifierQuery);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.common.util.EList < org.emftext.language.java.classifiers.ConcreteClassifier > result = new org.emftext.language.java.util.UniqueEList < org.emftext.language.java.classifiers.ConcreteClassifier > ( ) ; \nfor ( org.eclipse.emf.ecore.EObject classifier : org.emftext.language.java.JavaClasspath .get ( this ) .getClassifiers ( packageName , classifierQuery ) ) { \n\tresult .add ( ( org.emftext.language.java.classifiers.ConcreteClassifier ) classifier ) ; \n} \nreturn result ; \n'"
   * @generated
   */
  EList<ConcreteClassifier> getConcreteClassifierProxies(String packageName, String classifierQuery);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the <code>org.emftext.language.java.classifiers.Class</code>
   *  representing the class with the given name located in <code>java.lang</code>.
   *  
   *  @param name name of the Class
   *  @return the Class
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='if ( this .eResource ( ) == null ) { \n\tthrow new java.lang.IllegalArgumentException ( \"object context element must have a resource\" ) ; \n} \norg.emftext.language.java.classifiers.Class classClass = ( org.emftext.language.java.classifiers.Class ) getConcreteClassifierProxy ( \"java.lang.\" + name ) ; \nclassClass = ( org.emftext.language.java.classifiers.Class ) org.eclipse.emf.ecore.util.EcoreUtil .resolve ( classClass , this ) ; \nreturn classClass ; \n'"
   * @generated
   */
  org.emftext.language.java.classifiers.Class getLibClass(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the <code>org.emftext.language.java.classifiers.Interface</code>
   *  representing the interface with the given name located in <code>java.lang</code>.
   *  
   *  @param name name of the Interface
   *  @return the Class
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='if ( this .eResource ( ) == null ) { \n\tthrow new java.lang.IllegalArgumentException ( \"object context element  must have a resource\" ) ; \n} \norg.emftext.language.java.classifiers.ConcreteClassifier classClass = getConcreteClassifierProxy ( \"java.lang.\" + name ) ; \nreturn ( org.emftext.language.java.classifiers.Interface ) org.eclipse.emf.ecore.util.EcoreUtil .resolve ( classClass , this ) ; \n'"
   * @generated
   */
  Interface getLibInterface(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the <code>org.emftext.language.java.classifiers.Class</code>
   *  representing <code>java.lang.Class</code>.
   *  
   *  @return the Class
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return getLibClass ( \"Class\" ) ; \n'"
   * @generated
   */
  org.emftext.language.java.classifiers.Class getClassClass();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the <code>org.emftext.language.java.classifiers.Class</code>
   *  representing <code>java.lang.Object</code>.
   *  
   *  @return the Class
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return getLibClass ( \"Object\" ) ; \n'"
   * @generated
   */
  org.emftext.language.java.classifiers.Class getObjectClass();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the <code>org.emftext.language.java.classifiers.Class</code>
   *  representing <code>java.lang.String</code>.
   *  
   *  @return the Class
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return getLibClass ( \"String\" ) ; \n'"
   * @generated
   */
  org.emftext.language.java.classifiers.Class getStringClass();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the <code>org.emftext.language.java.classifiers.Interface</code>
   *  representing <code>java.lang.annotation.Annotation</code>.
   *  
   *  @return the Class
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='if ( this .eResource ( ) == null ) { \n\tthrow new java.lang.IllegalArgumentException ( \"object context element must have a resource\" ) ; \n} \norg.emftext.language.java.classifiers.Interface annotationClass = ( org.emftext.language.java.classifiers.Interface ) org.eclipse.emf.ecore.util.EcoreUtil .resolve ( getConcreteClassifierProxy ( \"java.lang.annotation.Annotation\" ) , this ) ; \nreturn annotationClass ; \n'"
   * @generated
   */
  Interface getAnnotationInterface();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the containing annotation instance for the given element.
   *  
   *  @param value
   *  @return containing annotation instance
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.ecore.EObject value = this ; \nwhile ( ! ( value instanceof org.emftext.language.java.annotations.AnnotationInstance ) && value != null ) { \n\tvalue = value .eContainer ( ) ; \n} \nreturn ( org.emftext.language.java.annotations.AnnotationInstance ) value ; \n'"
   * @generated
   */
  AnnotationInstance getContainingAnnotationInstance();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the containing anonymous class for the given element.
   *  
   *  @param value
   *  @return containing anonymous class 
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.ecore.EObject value = this ; \nwhile ( //do not jump over other classifiers \n! ( value instanceof org.emftext.language.java.classifiers.AnonymousClass ) && ! ( value instanceof org.emftext.language.java.classifiers.ConcreteClassifier ) && value != null ) { \n\tvalue = value .eContainer ( ) ; \n} \nif ( ! ( value instanceof org.emftext.language.java.classifiers.AnonymousClass ) ) { \n\treturn null ; \n} \nreturn ( org.emftext.language.java.classifiers.AnonymousClass ) value ; \n'"
   * @generated
   */
  AnonymousClass getContainingAnonymousClass();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the containing classifier for the given element.
   *  
   *  @param value
   *  @return containing classifier
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.ecore.EObject value = this ; \nwhile ( ! ( value instanceof org.emftext.language.java.classifiers.ConcreteClassifier ) && value != null ) { \n\tvalue = value .eContainer ( ) ; \n} \nreturn ( org.emftext.language.java.classifiers.ConcreteClassifier ) value ; \n'"
   * @generated
   */
  ConcreteClassifier getContainingConcreteClassifier();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the containing compilation unit for the given element.
   *  
   *  @param value
   *  @return containing compilation unit
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.ecore.EObject value = this ; \nwhile ( ! ( value instanceof org.emftext.language.java.containers.CompilationUnit ) && value != null ) { \n\tvalue = value .eContainer ( ) ; \n} \nreturn ( org.emftext.language.java.containers.CompilationUnit ) value ; \n'"
   * @generated
   */
  CompilationUnit getContainingCompilationUnit();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.emftext.language.java.containers.CompilationUnit cu = getContainingCompilationUnit ( ) ; \nif ( cu == null ) { \n\treturn null ; \n} \nint idx = cu .getNamespaces ( ) .size ( ) ; \nif ( cu .getName ( ) != null ) { \n\tchar [] fullName = cu .getName ( ) .toCharArray ( ) ; \n\tfor ( int i = 0 ; i < fullName .length ; i ++ ) { \n\t\tif ( fullName [ i ] == \'$\' ) { \n\t\t\tidx -- ; \n\t\t} \n\t} \n} \nreturn new org.eclipse.emf.common.util.BasicEList < java.lang.String > ( cu .getNamespaces ( ) .subList ( 0 , idx ) ) ; \n'"
   * @generated
   */
  EList<String> getContainingPackageName();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  Finds the classifier that is the parent of this element. If 
   *  this element is an inner classifier the parent classifier does
   *  not necessarily contain this element, since it can reside in 
   *  a different compilation unit when stored in byte code.
   *  
   *  @param value
   *  @return containing classifier
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.emftext.language.java.classifiers.ConcreteClassifier classifier = getContainingConcreteClassifier ( ) ; \nif ( classifier == null ) { \n\torg.emftext.language.java.containers.CompilationUnit cu = getContainingCompilationUnit ( ) ; \n\t//maybe the outer classifier is in an extra cu\nclassifier = ( org.emftext.language.java.classifiers.ConcreteClassifier ) org.eclipse.emf.ecore.util.EcoreUtil .resolve ( getConcreteClassifierProxy ( cu .getNamespacesAsString ( ) ) , this ) ; \n\tif ( classifier .eIsProxy ( ) ) { \n\t\tclassifier = null ; \n\t} \n} \nreturn classifier ; \n'"
   * @generated
   */
  ConcreteClassifier getParentConcreteClassifier();

} // Commentable
