/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.generics.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.emftext.language.java.annotations.provider.JavaEditPlugin;

import org.emftext.language.java.classifiers.provider.ClassifierItemProvider;

import org.emftext.language.java.generics.GenericsPackage;
import org.emftext.language.java.generics.TypeParameter;

import org.emftext.language.java.types.TypesFactory;

/**
 * This is the item provider adapter for a {@link org.emftext.language.java.generics.TypeParameter} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class TypeParameterItemProvider
  extends ClassifierItemProvider
  implements
    IEditingDomainItemProvider,
    IStructuredItemContentProvider,
    ITreeItemContentProvider,
    IItemLabelProvider,
    IItemPropertySource
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TypeParameterItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

    }
    return itemPropertyDescriptors;
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES);
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns TypeParameter.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object getImage(Object object)
  {
    return overlayImage(object, getResourceLocator().getImage("full/obj16/TypeParameter"));
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getText(Object object)
  {
    String label = ((TypeParameter)object).getName();
    return label == null || label.length() == 0 ?
      getString("_UI_TypeParameter_type") :
      getString("_UI_TypeParameter_type") + " " + label;
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(TypeParameter.class))
    {
      case GenericsPackage.TYPE_PARAMETER__EXTEND_TYPES:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
   * that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createClassifierReference()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createNamespaceClassifierReference()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createBoolean()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createByte()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createChar()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createDouble()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createFloat()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createInt()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createLong()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createShort()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETER__EXTEND_TYPES,
         TypesFactory.eINSTANCE.createVoid()));
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ResourceLocator getResourceLocator()
  {
    return JavaEditPlugin.INSTANCE;
  }

}
