/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.members;

import org.eclipse.emf.common.util.EList;
import org.emftext.language.java.classifiers.ConcreteClassifier;
import org.emftext.language.java.commons.Commentable;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Member Container</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.java.members.MemberContainer#getMembers <em>Members</em>}</li>
 *   <li>{@link org.emftext.language.java.members.MemberContainer#getDefaultMembers <em>Default Members</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.java.members.MembersPackage#getMemberContainer()
 * @model abstract="true"
 * @generated
 */
public interface MemberContainer extends Commentable
{
  /**
   * Returns the value of the '<em><b>Members</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.java.members.Member}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Members</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Members</em>' containment reference list.
   * @see org.emftext.language.java.members.MembersPackage#getMemberContainer_Members()
   * @model containment="true" resolveProxies="true"
   * @generated
   */
  EList<Member> getMembers();

  /**
   * Returns the value of the '<em><b>Default Members</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.java.members.Member}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Default Members</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Default Members</em>' containment reference list.
   * @see org.emftext.language.java.members.MembersPackage#getMemberContainer_DefaultMembers()
   * @model containment="true" resolveProxies="true" transient="true"
   * @generated
   */
  EList<Member> getDefaultMembers();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  @param name
   *  @return classifier with the given name defined in this member container
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='for ( org.emftext.language.java.members.Member member : getMembers ( ) ) { \n\tif ( member instanceof org.emftext.language.java.classifiers.ConcreteClassifier && name .equals ( member .getName ( ) ) ) { \n\t\treturn ( org.emftext.language.java.classifiers.ConcreteClassifier ) member ; \n\t} \n} \nfor ( org.emftext.language.java.members.Member member : getDefaultMembers ( ) ) { \n\tif ( member instanceof org.emftext.language.java.classifiers.ConcreteClassifier && name .equals ( member .getName ( ) ) ) { \n\t\treturn ( org.emftext.language.java.classifiers.ConcreteClassifier ) member ; \n\t} \n} \nreturn null ; \n'"
   * @generated
   */
  ConcreteClassifier getContainedClassifier(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  @param name
   *  @return field with the given name defined in this member container
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='for ( org.emftext.language.java.members.Member member : getMembers ( ) ) { \n\tif ( member instanceof org.emftext.language.java.members.Field && name .equals ( member .getName ( ) ) ) { \n\t\treturn ( org.emftext.language.java.members.Field ) member ; \n\t} \n} \nfor ( org.emftext.language.java.members.Member member : getDefaultMembers ( ) ) { \n\tif ( member instanceof org.emftext.language.java.members.Field && name .equals ( member .getName ( ) ) ) { \n\t\treturn ( org.emftext.language.java.members.Field ) member ; \n\t} \n} \nreturn null ; \n'"
   * @generated
   */
  Field getContainedField(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   *  @param name
   *  @return method with the given name defined in this member container;
   *          null, if there is no such method 
   *          or if there are multiple methods with the same name
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='org.emftext.language.java.members.Method found = null ; \nfor ( org.emftext.language.java.members.Member member : getMembers ( ) ) { \n\tif ( member instanceof org.emftext.language.java.members.Method && name .equals ( member .getName ( ) ) ) { \n\t\tif ( found != null ) { \n\t\t\treturn null ; \n\t\t} else { \n\t\t\tfound = ( org.emftext.language.java.members.Method ) member ; \n\t\t} \n\t} \n} \nfor ( org.emftext.language.java.members.Member member : getDefaultMembers ( ) ) { \n\tif ( member instanceof org.emftext.language.java.members.Method && name .equals ( member .getName ( ) ) ) { \n\t\tif ( found != null ) { \n\t\t\treturn null ; \n\t\t} else { \n\t\t\tfound = ( org.emftext.language.java.members.Method ) member ; \n\t\t} \n\t} \n} \nreturn found ; \n'"
   * @generated
   */
  Method getContainedMethod(String name);

} // MemberContainer
