/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package org.emftext.language.java.members.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.emftext.language.java.arrays.ArraysFactory;
import org.emftext.language.java.arrays.ArraysPackage;

import org.emftext.language.java.generics.GenericsFactory;
import org.emftext.language.java.generics.GenericsPackage;

import org.emftext.language.java.members.MembersPackage;
import org.emftext.language.java.members.Method;

import org.emftext.language.java.modifiers.ModifiersPackage;

import org.emftext.language.java.parameters.ParametersFactory;
import org.emftext.language.java.parameters.ParametersPackage;

import org.emftext.language.java.types.TypesFactory;
import org.emftext.language.java.types.TypesPackage;

/**
 * This is the item provider adapter for a {@link org.emftext.language.java.members.Method} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class MethodItemProvider
  extends MemberItemProvider
  implements
    IEditingDomainItemProvider,
    IStructuredItemContentProvider,
    ITreeItemContentProvider,
    IItemLabelProvider,
    IItemPropertySource
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MethodItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

      addAnnotationsAndModifiersPropertyDescriptor(object);
    }
    return itemPropertyDescriptors;
  }

  /**
   * This adds a property descriptor for the Annotations And Modifiers feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addAnnotationsAndModifiersPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_AnnotableAndModifiable_annotationsAndModifiers_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_AnnotableAndModifiable_annotationsAndModifiers_feature", "_UI_AnnotableAndModifiable_type"),
         ModifiersPackage.Literals.ANNOTABLE_AND_MODIFIABLE__ANNOTATIONS_AND_MODIFIERS,
         true,
         false,
         true,
         null,
         null,
         null));
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE);
      childrenFeatures.add(ArraysPackage.Literals.ARRAY_TYPEABLE__ARRAY_DIMENSIONS_BEFORE);
      childrenFeatures.add(ArraysPackage.Literals.ARRAY_TYPEABLE__ARRAY_DIMENSIONS_AFTER);
      childrenFeatures.add(GenericsPackage.Literals.TYPE_PARAMETRIZABLE__TYPE_PARAMETERS);
      childrenFeatures.add(ParametersPackage.Literals.PARAMETRIZABLE__PARAMETERS);
      childrenFeatures.add(MembersPackage.Literals.EXCEPTION_THROWER__EXCEPTIONS);
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getText(Object object)
  {
    String label = ((Method)object).getName();
    return label == null || label.length() == 0 ?
      getString("_UI_Method_type") :
      getString("_UI_Method_type") + " " + label;
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(Method.class))
    {
      case MembersPackage.METHOD__TYPE_REFERENCE:
      case MembersPackage.METHOD__ARRAY_DIMENSIONS_BEFORE:
      case MembersPackage.METHOD__ARRAY_DIMENSIONS_AFTER:
      case MembersPackage.METHOD__TYPE_PARAMETERS:
      case MembersPackage.METHOD__PARAMETERS:
      case MembersPackage.METHOD__EXCEPTIONS:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
   * that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createClassifierReference()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createNamespaceClassifierReference()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createBoolean()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createByte()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createChar()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createDouble()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createFloat()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createInt()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createLong()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createShort()));

    newChildDescriptors.add
      (createChildParameter
        (TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE,
         TypesFactory.eINSTANCE.createVoid()));

    newChildDescriptors.add
      (createChildParameter
        (ArraysPackage.Literals.ARRAY_TYPEABLE__ARRAY_DIMENSIONS_BEFORE,
         ArraysFactory.eINSTANCE.createArrayDimension()));

    newChildDescriptors.add
      (createChildParameter
        (ArraysPackage.Literals.ARRAY_TYPEABLE__ARRAY_DIMENSIONS_AFTER,
         ArraysFactory.eINSTANCE.createArrayDimension()));

    newChildDescriptors.add
      (createChildParameter
        (GenericsPackage.Literals.TYPE_PARAMETRIZABLE__TYPE_PARAMETERS,
         GenericsFactory.eINSTANCE.createTypeParameter()));

    newChildDescriptors.add
      (createChildParameter
        (ParametersPackage.Literals.PARAMETRIZABLE__PARAMETERS,
         ParametersFactory.eINSTANCE.createOrdinaryParameter()));

    newChildDescriptors.add
      (createChildParameter
        (ParametersPackage.Literals.PARAMETRIZABLE__PARAMETERS,
         ParametersFactory.eINSTANCE.createVariableLengthParameter()));

    newChildDescriptors.add
      (createChildParameter
        (MembersPackage.Literals.EXCEPTION_THROWER__EXCEPTIONS,
         TypesFactory.eINSTANCE.createNamespaceClassifierReference()));
  }

  /**
   * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection)
  {
    Object childFeature = feature;
    Object childObject = child;

    boolean qualify =
      childFeature == TypesPackage.Literals.TYPED_ELEMENT__TYPE_REFERENCE ||
      childFeature == MembersPackage.Literals.EXCEPTION_THROWER__EXCEPTIONS ||
      childFeature == ArraysPackage.Literals.ARRAY_TYPEABLE__ARRAY_DIMENSIONS_BEFORE ||
      childFeature == ArraysPackage.Literals.ARRAY_TYPEABLE__ARRAY_DIMENSIONS_AFTER;

    if (qualify)
    {
      return getString
        ("_UI_CreateChild_text2",
         new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
    }
    return super.getCreateChildText(owner, feature, child, selection);
  }

}
